SystemOrganization addCategory: #'Mason-Creole'!

MDFileJob subclass: #MDRenderCreoleJob
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-Creole'!

!MDRenderCreoleJob methodsFor: 'accessing' stamp: 'cwp 11/19/2009 10:18'!
cssRef
	^ dest parent basename withExtension: '.css'! !

!MDRenderCreoleJob methodsFor: 'running' stamp: 'cwp 1/10/2009 13:20'!
parseCreole
	| in |
	[in := FileStream oldFileNamed: source asString.
	^ CreoleDocumentParser parseFrom: in]
		ensure: [in ifNotNil: [in close]].
	! !

!MDRenderCreoleJob methodsFor: 'running' stamp: 'cwp 1/10/2009 22:40'!
run
	| node |
	node := self parseCreole.
	CreoleLinker link: node at: dest parent asString, '/'.
	self writeHtml: node! !

!MDRenderCreoleJob methodsFor: 'accessing' stamp: 'cwp 1/10/2009 13:30'!
title
	| basename words |
	basename := source basename.
	(basename endsWith: '.creole') ifTrue:
		[basename := basename allButLast: 7].
	words := String streamContents:
		[:out | 
		basename do:
			[:character |
			character isUppercase ifTrue: [out space].
			out nextPut: character]].
	^ words withBlanksCondensed withBlanksTrimmed! !

!MDRenderCreoleJob methodsFor: 'running' stamp: 'cwp 1/10/2009 13:25'!
writeFooterOn: aStream
	aStream nextPutAll: '</body></html>'! !

!MDRenderCreoleJob methodsFor: 'running' stamp: 'cwp 1/10/2009 23:44'!
writeHeaderOn: aStream
	aStream
		nextPutAll: '<html><head><title>';
		nextPutAll: self title;
		nextPutAll: '</title><link rel="stylesheet" href="';
		nextPutAll: self cssRef;
		nextPutAll: '" type="text/css" media="screen" charset="utf-8"></head><body>'! !

!MDRenderCreoleJob methodsFor: 'running' stamp: 'cwp 1/10/2009 22:31'!
writeHtml: aNode
	| out |
	[out := FileStream newFileNamed: dest asString.
	self writeHeaderOn: out.
	CreoleHtmlPrinter print: aNode on: out.
	self writeFooterOn: out]
		ensure: [out ifNotNil: [out close]]! !
